local UnitName = CT_RA_UnitName;

tinsert(UISpecialFrames, "CT_RA_ChangelogFrame");
CT_RACHANGES_HEIGHT = 500;
function CT_RAChanges_DisplayDialog()
	CT_RA_ChangelogFrame:SetHeight(CT_RACHANGES_HEIGHT+25);
	-- Initialize dialog
		-- Set title
	CT_RA_ChangelogFrameTitle:SetText(CT_RA_Changes["title"]);
	
		-- Show sections
	local section, totalHeight = 1, 0;
	while ( CT_RA_Changes["section" .. section] ) do
		local objSection = _G["CT_RA_ChangelogFrameScrollFrameSection" .. section];
		local part, partHeights = 1, 0;
		
			-- Show section
		objSection:Show();
		
			-- Set section title
		_G[objSection:GetName() .. "Title"]:SetText(CT_RA_Changes["section" .. section]["title"]);
		
			-- Show parts
		while ( CT_RA_Changes["section" .. section][part] ) do
			local objPart = _G["CT_RA_ChangelogFrameScrollFrameSection" .. section .. "Part" .. part];
			
				-- Show part
			objPart:Show();
			
				-- Set part stuff
			_G[objPart:GetName() .. "Text"]:SetText(CT_RA_Changes["section" .. section][part][2]);
			_G[objPart:GetName() .. "Text"]:SetHeight(CT_RA_Changes["section" .. section][part][1]);
			objPart:SetHeight(CT_RA_Changes["section" .. section][part][1]);
			partHeights = partHeights + CT_RA_Changes["section" .. section][part][1] + 5;
			part = part + 1;
		end
		local addedHeight = ( CT_RA_Changes["section" .. section]["addedHeight"] or 0);
		objSection:SetHeight(partHeights+35+addedHeight);
		totalHeight = totalHeight + partHeights+35+addedHeight;
		section = section + 1;
	end
	CT_RA_ChangelogFrameScrollFrameSection:SetHeight(totalHeight);
	ShowUIPanel(CT_RA_ChangelogFrame);
	CT_RA_ChangelogFrameScrollFrame:UpdateScrollChildRect();
	local minVal, maxVal = CT_RA_ChangelogFrameScrollFrameScrollBar:GetMinMaxValues();
	if ( maxVal == 0 ) then
		CT_RA_ChangelogFrameScrollFrameScrollBar:Hide();
	else
		CT_RA_ChangelogFrameScrollFrameScrollBar:Show();
	end
	CT_RA_ChangelogFrameScrollFrame:SetHeight(CT_RACHANGES_HEIGHT-75);
end

-- Add slash command
CT_RA_RegisterSlashCmd("/ralog", "Shows the changelog for this version.", 15, "RALOG", CT_RAChanges_DisplayDialog, "/ralog");

CT_RA_Changes = {
	["title"] = "CT_RaidAssist Update History (3.300 to 4.006)",
	
	-- |bxxxx|eb (yellow text)
	-- |gxxxx|eg (red text)

	["section1"] = {
		["title"] = "Version 4.006",
		{ 30, "Fixed a problem when trying to assign main tank status to a player with an Alt-135 character in their name." },
		{ 30, "Fixed an issue where it would sometimes display a hyphen after the name of the player in the MTPlayers frame for players on the same server as you." },
		["addedHeight"] = 10,
	},
	["section2"] = {
		["title"] = "Version 4.005",
		{ 30, "Fixed a problem that was causing some raid frames to be positioned at the top left of the screen due to a change in the 4.0.3 WoW patch." },
		{ 30, "Main tanks and player targets are once again being sorted in the order they were added now that the 4.0.3 WoW patch has re-implemented the ability to do so." },
		{ 30, "Added an option to sort main tanks alphabetically." },
		{ 30, "Added an option to sort player targets alphabetically." },
		["addedHeight"] = 10,
	},
	["section3"] = {
		["title"] = "Version 4.004",
		{ 30, "Fixed a problem where the raid frame positions were not being restored properly when joining a raid." },
		["addedHeight"] = 10,
	},
	["section4"] = {
		["title"] = "Version 4.003",
		{ 50, "Due to a change made by Blizzard, it is not currently possible for the main tanks to always be displayed in the order that they were assigned, so the tanks are now being sorted by name." },
		{ 30, "Fixed a problem that was causing the main tank targets to sometimes be displayed beside the wrong main tank players." },
		{ 30, "Fixed a problem that was causing you to select the main tank rather than the tank's target when clicking on a main tank target frame." },
		{ 30, "Fixed a problem that was causing everyone to appear to be out of range." },
		{ 30, "Fixed AFK and DND detection." },
		{ 30, "Localized spell names are now being obtained using spell id numbers and GetSpellInfo()." },
		{ 30, "Now uses the correct color for the hunter's power bar." },
		{ 30, "Updated the reagents checked for by the /rareg command." },
		{ 30, "Changed Rebirth cooldown to 30 minutes, Soulstone cooldown to 15 minutes, and Reincarnation cooldown to 30 minutes." },
		{ 30, "Updated the names of the spells used by healing classes to detect if a raid member is in range." },
		{ 30, "Updated the types of debuffs that each class can cure." },
		{ 30, "The resurrection monitor now also watches for the 'Revive' spell." },
		{ 30, "Added 'Prayer of Mending' to the buff options window." },
		{ 30, "Removed spells that are no longer in the game." },
		["addedHeight"] = 10,
	},
	["section5"] = {
		["title"] = "Version 4.002",
		{ 30, "Updated for the WoW 4.0 patch." },
		["addedHeight"] = 10,
	},
	["section6"] = {
		["title"] = "Version 3.303",
		{ 30, "Miscellaneous internal changes." },
		["addedHeight"] = 10,
	},
	["section7"] = {
		["title"] = "Version 3.302",
		{ 30, "Fixed a chat frame error." },
		["addedHeight"] = 10,
	},
	["section8"] = {
		["title"] = "Version 3.301",
		{ 30, "Added the command /ctraid as an alternative to the existing /raoptions and /ctra commands." },
		{ 30, "Fixed a debuff display issue that was occuring when a new debuff replaced an existing debuff on a player and the number of debuffs didn't change." },
		{ 30, "Fixed a problem involving the names of players on the same server as you. This was causing some CTRA messages in the addon channel to be ignored." },
		{ 50, "Raid target icons are now displayed on all raid frames (if the option to show the icons is enabled in CT_RaidAssist). This can be useful when used in combination with a boss fight addon that places raid target icons on players that get certain debuffs." },
		["addedHeight"] = 10,
	},
	["section9"] = {
		["title"] = "Version 3.300",
		{ 30, "Updated to work with the WoW 3.3 patch." },
		{ 60, "CT_RaidAssist no longer uses the 'RAID' addon channel while in a battleground. This prevents CT_RaidAssist from causing a 'You aren't in a party.' message to appear in the chat window. If you still get that message, then you probably have another addon that is using the 'RAID' addon channel in a battleground." },
		{ 30, "Changed the cooldown time for the Druid's Rebirth spell from 30 to 20 minutes." },
		{ 30, "Fixed a bug that might cause some raid frames to not update correctly." },
		["addedHeight"] = 10,
	},
	-- Max 10 sections.
};
for k, v in pairs(CT_RA_Changes) do
	if ( type(v) == "table" ) then
		for key, val in pairs(v) do
			if ( type(val) == "table" ) then
				while ( string.find(val[2], "|[bg].-|e[bg]") ) do
					CT_RA_Changes[k][key][2] = string.gsub(val[2], "^(.*)|b(.-)|eb(.*)$", "%1|c00FFD100%2|r%3");
					CT_RA_Changes[k][key][2] = string.gsub(CT_RA_Changes[k][key][2], "^(.*)|g(.-)|eg(.*)$", "%1|c00FF0000%2|r%3");
				end
			end
		end
	end
end